function X=pku(Uhly, G, rg, rf, re)
% prima kinematicka uloha
% velka pismena za zacatku oznacuji sloupcove vektory
% G bod G absolutnich souradnicich (viz obrazek)
% rg delka ramena zacinajici v G
% rf delka ramena zacinajici v F
% re delka ramena zacinajici v E
% X pozice chpadla v absolutnich souradnicich
% Uhly je [g;f;e] = uhly v rad v kloubech G,F,E

% Uhly = [2.35 1.2 -1.7]';
% G = [4.5 0 5.5]';
% rg = 0.5;
% rf = 3.3;
% re = 3.3;

  G = [G; 1];
  g = Uhly(1);
  f = Uhly(2);
  e = Uhly(3);

% translace pocatku do G
  TG = [[eye(3); zeros(1,3)] G];

% rotace v G kolem z o uhel g
  RG = [[[cos(-g) sin(-g) 0; -sin(-g) cos(-g) 0; 0 0 1]; zeros(1,3)] [0 0 0 1]'];

% translace G do F podle -z
  TF = [[eye(3); zeros(1,3)] [0 0 -rg 1]'];

% rotace v F kolem y o uhel f
  RF = [[[cos(-f) 0 sin(-f); 0 1 0; -sin(-f) 0 cos(-f)]; zeros(1,3)] [0 0 0 1]'];

% translace F do E podle -z
  TE = [[eye(3); zeros(1,3)] [0 0 -rf 1]'];

% rotace v E kolem y o uhel e
  RE = [[[cos(-e) 0 sin(-e); 0 1 0; -sin(-e) 0 cos(-e)]; zeros(1,3)] [0 0 0 1]'];

% chapadlo lezi na ose -z ve vdalenosti re
  ch = [0 0 -re 1]';

  Xh = TG*RG*TF*RF*TE*RE*ch;
  X = Xh(1:3);
%end
